package output;

import java.util.ArrayList;

/**
 * Haus dient hier nur als Beispiel einer hierarchischen Datenstruktur
 */
public class Haus
{

    /** Bezeichnung */
    private String bezeichnung;

    /** set Bezeichnung */
    public void setBezeichnung(String newBezeichnung)
    {
        bezeichnung = newBezeichnung;
    }

    /** get Bezeichnung */
    public String getBezeichnung()
    {
        return bezeichnung;
    }

    /** list of Etage */
    private ArrayList etagen = new ArrayList();

    /** add Etage */
    public void addEtagen(Etage newEtagen)
    {
        etagen.add(newEtagen);
    }

    /** get element count Etage */
    public int getEtagenCount()
    {
        return etagen.size();
    }

    /** get element for specified index Etage */
    public Etage getEtagen(int pIndex)
    {
        return (Etage) etagen.get(pIndex);
    }

    /** Keller */
    private Keller keller;

    /** set Keller */
    public void setKeller(Keller newKeller)
    {
        keller = newKeller;
    }

    /** get Keller */
    public Keller getKeller()
    {
        return keller;
    }

    public static void main(String[] args)
    {
        //----------------------------------
        // Artefakt zum Aufbau der Struktur
        //----------------------------------
        boolean bFake = true; // bFake dient nur zum Bedienen der while-Schleifen

        Haus haus = new Haus();
        haus.setBezeichnung((String) null);
        //Schleife Etage etagen
        while(bFake)
        {
            Etage etagen = new Etage();
            etagen.setLevel(0);
            //Schleife Wohnung wohnungen
            while(bFake)
            {
                Wohnung wohnungen = new Wohnung();
                wohnungen.setBezeichnung((String) null);
                //Schleife Person einwohner
                while(bFake)
                {
                    wohnungen.addEinwohner(new Person());
                }
                //Schleife Raum raueme
                while(bFake)
                {
                    Raum raueme = new Raum();
                    raueme.setBezeichnung((String) null);
                    raueme.setBreite(0);
                    raueme.setLaenge(0);
                    wohnungen.addRaueme(raueme);
                }
                etagen.addWohnungen(wohnungen);
            }
            haus.addEtagen(etagen);
        }
        haus.setKeller(new Keller());



        //---------------------------------------
        // Artefakt zum Durchlaufen der Struktur
        //---------------------------------------
        //Schleife Etage etagen
        for(int iEtagen = 0 ; iEtagen < haus.getEtagenCount() ; iEtagen++)
        {
            Etage etagen = haus.getEtagen(iEtagen);
            //Schleife Wohnung wohnungen
            for(int iWohnungen = 0 ; iWohnungen < etagen.getWohnungenCount() ; iWohnungen++)
            {
                Wohnung wohnungen = etagen.getWohnungen(iWohnungen);
                //Schleife Person einwohner
                for(int iEinwohner = 0 ; iEinwohner < wohnungen.getEinwohnerCount() ; iEinwohner++)
                {
                    Person einwohner = wohnungen.getEinwohner(iEinwohner);
                }
                //Schleife Raum raueme
                for(int iRaueme = 0 ; iRaueme < wohnungen.getRauemeCount() ; iRaueme++)
                {
                    Raum raueme = wohnungen.getRaueme(iRaueme);
                }
            }
        }
    }

}